// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.

/// <p>Definition of content in the response stream.</p>
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq)]
pub enum ResponseStream {
    /// <p>Content included in the response.</p>
    Chunk(crate::types::PayloadPart),
    /// The `Unknown` variant represents cases where new union variant was received. Consider upgrading the SDK to the latest available version.
    /// An unknown enum variant
    ///
    /// _Note: If you encounter this error, consider upgrading your SDK to the latest version._
    /// The `Unknown` variant represents cases where the server sent a value that wasn't recognized
    /// by the client. This can happen when the server adds new functionality, but the client has not been updated.
    /// To investigate this, consider turning on debug logging to print the raw HTTP response.
    #[non_exhaustive]
    Unknown,
}
impl ResponseStream {
    #[allow(irrefutable_let_patterns)]
    /// Tries to convert the enum instance into [`Chunk`](crate::types::ResponseStream::Chunk), extracting the inner [`PayloadPart`](crate::types::PayloadPart).
    /// Returns `Err(&Self)` if it can't be converted.
    pub fn as_chunk(&self) -> ::std::result::Result<&crate::types::PayloadPart, &Self> {
        if let ResponseStream::Chunk(val) = &self {
            ::std::result::Result::Ok(val)
        } else {
            ::std::result::Result::Err(self)
        }
    }
    /// Returns true if this is a [`Chunk`](crate::types::ResponseStream::Chunk).
    pub fn is_chunk(&self) -> bool {
        self.as_chunk().is_ok()
    }
    /// Returns true if the enum instance is the `Unknown` variant.
    pub fn is_unknown(&self) -> bool {
        matches!(self, Self::Unknown)
    }
}
impl ::std::fmt::Debug for ResponseStream {
    fn fmt(&self, f: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
        match self {
            ResponseStream::Chunk(_) => f.debug_tuple("*** Sensitive Data Redacted ***").finish(),
            ResponseStream::Unknown => f.debug_tuple("Unknown").finish(),
        }
    }
}
